///////////////////////////////
#include <acknex.h>
//#include <default.c>
#include <ackphysx.h>
///////////////////////////////
#include "quiz.c"
///////////////////////////////

int total_levels=5;
int game_started=0;

int total_balls;
int current_level=1;
int at_menu=0;
int cam_height=800;

ENTITY* cueball;
PANEL	*background;
PANEL *menupan;
PANEL* helpp;
PANEL* quiz_panel;
var playing=0;
int score=0;

VECTOR playball_startpos[256];
VECTOR cue_startpos;
int playballindex=0;

action hole_action()
{
	set(my,PASSABLE);
	pXent_settype(my,0,NULL);
	while(my)
	{
		ENTITY* ent;
		for(ent = ent_next(NULL);ent;ent=ent_next(ent)) 
		{	
			if(ent!=NULL)
			{
				if(is(ent,FLAG1))//playball?
				{
					if(vec_dist(ent.x,my.x)<=30)//ball in hole?
					{
						wait(1);
						pXent_settype(ent,0,NULL);
						ent_remove(ent);
						score+=100;
					}
				}
				if(is(ent,FLAG2))//cueball?
				{
					if(vec_dist(ent.x,my.x)<=30)//ball in hole?
					{
						pXent_setvelocity(ent,vector(0,0,0));
						pXent_setposition(ent,cue_startpos);			
					}
				}
			}
		}
		wait(1);
	}
}

action spawn_playball()
{
	//safe pos
	playballindex+=1;
	my.skill1=playballindex;
	vec_set(playball_startpos[my.skill1],my.x);
	
	set(my,FLAG1);//mark the playballs
	set(my,SHADOW);
	set(my,PASSABLE);
	pXent_settype(my,0,NULL);
	pXent_settype(my,PH_RIGID,PH_SPHERE);
	
	pXent_setdamping(my,50,50);
	pXent_setelasticity(my,100);
	pXent_setccdskeleton(my,nullvector,1);
	pXent_setmass(my,150);

	while(my)
	{
		VECTOR vel;
		pXent_getvelocity(my,vel,nullvector);
		
		if(my.x<0)//ball bounced off table
		{
			pXent_setvelocity(my,vector(0,0,0));
			pXent_setposition(my,playball_startpos[my.skill1]);			
		}
		if((vel.z>-15.0 && vel.z<15.0) && (vel.y>-15.0 && vel.y<15.0))
		{
			vec_scale(vel,0.5);
			pXent_setvelocity(my,vel);
		}
		
		//if slowed down enough
 		if((vel.z>-3.5 && vel.z<3.5) && (vel.y>-3.5 && vel.y<3.5))
 		{
 			vec_set(playball_startpos[my.skill1],my.x);//safe pos
 		}

		wait(1);
	}
}

void do_keyhelp()
{
	PANEL* p=pan_create("bmap=keyhelp.bmp",101);
	set(p,SHOW);
	at_menu=1;
	while(!key_esc)
	{
		wait(1);
	}
	at_menu=0;
	ptr_remove(p);
}

ENTITY *cue;
ENTITY* arrow;

action spawn_cueball()
{
	vec_set(cue_startpos,my.x);//safe pos
	
	cueball=my;
	set(my,FLAG2);//mark the cueball
	set(my,SHADOW);
	set(my,PASSABLE);

	pXent_settype(my,0,NULL);//deregister

	arrow=ent_create("arrow.mdl",my.x,NULL);//create powerbar
	//set(arrow,TRANSLUCENT);
	//arrow.alpha=50;

	pXent_settype(my,PH_RIGID,PH_SPHERE);
//	pXent_setmaxspeed(my,3.5);
	
	pXent_setfriction(my,500);
	pXent_setdamping(my,50,50);
	pXent_setelasticity(my,150);
	pXent_setccdskeleton(my,nullvector,1);
	pXent_setmass(my,250);
	
	//cue
	cue=ent_create("cue.mdl",my.x,NULL);
	cue.pan=-90;
	set(cue,SHADOW);

	var keyd=0;
	var _power=1;
	VECTOR shoot;
	game_started=1;

	while(me)
	{
		VECTOR vel;
		pXent_getvelocity(my,vel,nullvector);

		if(my.x<0)//ball bounced off table
		{
			pXent_setvelocity(my,vector(0,0,0));
			pXent_setposition(my,cue_startpos);			
		}
		//slow down
		if((vel.z>-15.0 && vel.z<15.0) && (vel.y>-15.0 && vel.y<15.0))
		{
			vec_scale(vel,0.5);
			pXent_setvelocity(my,vel);
		}
		//if slowed down enough
 		if((vel.z>-3.5 && vel.z<3.5) && (vel.y>-3.5 && vel.y<3.5))
 		{
 			vec_set(cue_startpos,my.x);//safe pos
			//power arrow
			VECTOR aimdir;
 			vec_set(arrow.x,vector(my.x+10,my.y,my.z));
			vec_set(aimdir,vector(500,0,0));
			vec_rotate(aimdir,arrow.pan);
			vec_add(aimdir,my.x);

			////aim line
			VECTOR aimhelp;
			vec_set(aimhelp,vector(0,-500,0));
			vec_rotate(aimhelp,arrow.pan);
			vec_add(aimhelp,my.x);
			draw_line3d(vector(my.x+10,my.y,my.z),NULL,100);
			draw_line3d(vector(aimhelp.x+10,aimhelp.y,aimhelp.z),COLOR_WHITE,100);

			//cue
			if(at_menu==0)
			arrow.roll+=mouse_force.x/5*time_step;//fine adjust with mouse
			vec_set(cue.x,vector(10,0,0));
			vec_add(cue.x,my.x);
			cue.tilt=-arrow.roll;
 		}

		arrow.scale_y=_power;

		if(!key_space)keyd=0;
		if(key_d && at_menu==0)//caurse adjust
		{
			//if slowed down enough
 			if((vel.z>-3.5 && vel.z<3.5) && (vel.y>-3.5 && vel.y<3.5))
			arrow.roll-=2*time_step;
		}
		if(key_a && at_menu==0)//caurse adjust
		{
			//if slowed down enough
 			if((vel.z>-3.5 && vel.z<3.5) && (vel.y>-3.5 && vel.y<3.5))
			arrow.roll+=2*time_step;
		}
		if(key_w && at_menu==0)//power
		{
			if(_power<3.5)//max
			{
				//if slowed down enough
				if((vel.z>-3.5 && vel.z<3.5) && (vel.y>-3.5 && vel.y<3.5))
				_power+=0.25*time_step;
			}
		}
		if(key_s && at_menu==0)//power
		{
			if(_power>0.25)//min
			{
				//if slowed down enough
				if((vel.z>-3.5 && vel.z<3.5) && (vel.y>-3.5 && vel.y<3.5))
				_power-=0.25*time_step;
			}
		}
		if(key_space && at_menu==0)//shoot
		{
			//if slowed down enough
			if(!keyd && (vel.z>-3.5 && vel.z<3.5) && (vel.y>-3.5 && vel.y<3.5))
			{
  				shoot.x =0;shoot.y = -100;shoot.z =0;
  				vec_scale(shoot,_power*3.5);
				vec_rotate(shoot,arrow.pan);
				pXent_addvelcentral(my,shoot);
				keyd=1;
			}
		}
		
		//back to menu
		if(key_q && at_menu==0)
		{
			if(cam_height>100)
			cam_height-=10*time_step;
		}
		if(key_e && at_menu==0)
		{
			if(cam_height<1500)
			cam_height+=10*time_step;
		}
		if(key_esc && at_menu==0)
		{
			set(background,SHOW);
			at_menu=1;
		}
		//key help
		if(key_f1 && at_menu==0)
		{
			do_keyhelp();
			wait_for(do_keyhelp);
		}
  		if(menupan!=NULL && at_menu==0)
  		{
  			draw_text(str_printf(NULL,"%d",score),100,18,COLOR_BLACK);
  			draw_text(str_printf(NULL,"%d (balls left:%d)",current_level,total_balls),250,18,COLOR_BLACK);
  		}
		wait(1);
	}
}

//count balls on table
void count_balls()
{
	ENTITY* ent;
	var count=0;
	for(ent = ent_next(NULL);ent;ent=ent_next(ent)) 
	{	
		if(ent!=NULL)
		{
			if(is(ent,FLAG1))//ball
			{
				count+=1;
			}
		}
	}	
	total_balls=count;
}

void init_physx()
{
//	physX_destroy();
	physX_open();
	pX_setgravity(vector(-15,0,0));
	pX_setccd(1);
}

void init_level(var level)
{
	playballindex=0;
	game_started=0;
	playballindex=0;
	total_balls=0;


	load_file("quiz.txt");
	int tot=get_total_questions();
	if(tot>0 && tot<total_levels+1)
	{
		if((level-1)<tot)
		{
			PANEL* pp=pan_create("bmap=menback.bmp",0);
			set(pp,SHOW);
			do_question(level-1);
			wait_for(do_question);
			score+=get_lastpoints();
			if(pp)ptr_remove(pp);
		}
	}

	if(level==1)
	{
		current_level=level;
		level_load("level1.wmb");
		wait_for(level_load);
	}
	if(level==2)
	{
		current_level=level;
		level_load("level2.wmb");
		wait_for(level_load);
	}
	if(level==3)
	{
		current_level=level;
		level_load("level3.wmb");
		wait_for(level_load);
	}
	if(level==4)
	{
		current_level=level;
		level_load("level4.wmb");
		wait_for(level_load);
	}
	if(level==5)
	{
		current_level=level;
		level_load("level5.wmb");
		wait_for(level_load);
	}
	vec_set(camera.pan,vector(180,0,0));
	
	playing=1;
}

void exit_game()
{
	physX_destroy();
	sys_exit(NULL);
}

void start_game()
{
	if(!playing)
	{
		if(menupan)reset(menupan,SHOW);
		if(helpp)reset(helpp,SHOW);
		if(background)reset(background,SHOW);
		if(!menupan)menupan=pan_create("bmap=menupanel.bmp",1);
		if(menupan)set(menupan,SHOW);
		init_level(1);
	}
	else
	{
		at_menu=0;
		if(menupan)set(menupan,SHOW);
		if(helpp)reset(helpp,SHOW);
		if(background)reset(background,SHOW);
	}
}

void help_screen()
{
	if(menupan)reset(menupan,SHOW);
	reset(background,SHOW);
	helpp=pan_create("bmap=helpscreen.bmp",100);
	set(helpp,SHOW);
	while(!key_esc)
	{
		wait(1);
	}
	reset(helpp,SHOW);
	set(background,SHOW);
}

void quiz_creator()
{
	int done=0;
	if(helpp)reset(helpp,SHOW);
	if(menupan)reset(menupan,SHOW);
	if(background)reset(background,SHOW);
	
	quiz_panel=pan_create("bmap=menback.bmp",100);
	set(quiz_panel,SHOW);
	create_quiz();
	
	while(!done)
	{
		if(key_esc)done=1;
		wait(1);
	}
	if(done==1)
	{
		if(quiz_panel)
		{
			reset(quiz_panel,SHOW);
			if(background)set(background,SHOW);
		}
	}
}

void do_menu()
{
	if(helpp)reset(helpp,SHOW);
	if(menupan)reset(menupan,SHOW);
	background=pan_create("bmap=menback.bmp",100);
	set(background,SHOW);
	mouse_mode = 4; //activate mouse

	BMAP* newquiz="newquiz.bmp";
	pan_setbutton(background,0,0,
     400-bmap_width(newquiz)/2,100,newquiz,newquiz,newquiz,NULL,quiz_creator,NULL,NULL);	

	BMAP* play="play.bmp";
	pan_setbutton(background,0,0,
     400-bmap_width(play)/2,190,play,play,play,NULL,start_game,NULL,NULL);	

	BMAP* help="help.bmp";
	pan_setbutton(background,0,0,
     400-bmap_width(help)/2,280,help,help,help,NULL,help_screen,NULL,NULL);	

	BMAP* quit="quit.bmp";
	pan_setbutton(background,0,0,
     400-bmap_width(quit)/2,370,quit,quit,quit,NULL,exit_game,NULL,NULL);	
}

function main()
{
	vec_set(screen_size,vector(800,600,0));
  
	vec_set(screen_color,vector(1,1,1)); // dark blue
	vec_set(sky_color,vector(1,1,1)); // dark blue
  
	video_window(NULL,NULL,0,"");
	d3d_antialias = 1;
	shadow_stencil = 3;
  
	fps_min=60;
	fps_max=60;

	do_menu();
	init_physx();


	while(1)
	{
		count_balls();//count balls;
		
		//camera follow cueball
  		if(cueball)vec_set(camera.x,vector(cam_height,cueball.y,cueball.z));
  		
  		if(playing==1 && game_started==1)
  		{
  			if(total_balls==0)//next level
  			{
				//go to next level
				if(current_level<total_levels)
				{
					ptr_remove(cue);
					ptr_remove(arrow);
					init_level(current_level+1);
				}
			}
  		}
		wait(1);
	}
}
